#!ruby
#**********************************************************************
# ruby p6_rankupdown.rb
#----------------------------------------------------------------------
# 内部用ランキングを作成する（ランキング対象：対象選手全員/最大9日分）
# 入力
#   FILE_RANKFILE   逆順の.d1ランクファイル一覧
# 出力
#   FILE_RANKING    内部用ランキングTXTファイル
#----------------------------------------------------------------------

require 'fileutils'
require './def_rating_files'
require './def_rating_meibo'


# 推移を表示する最大日数
filemax = 9

#######################################################################
# メインプログラム

#---------------------------------------------
# 項目名の行を出力する。
#---------------------------------------------
rankfile = File.open(FILE_RANKFILE, "r")
ranktxt = File.open(FILE_RANKING, "w")

meibo1 = rankfile.gets
meibo1.chomp!
date_m = meibo1.slice(4,2).to_i
date_d = meibo1.slice(6,2).to_i
date = sprintf("%d/%d",date_m, date_d)

# FILE_RANKING の1行目を出力
ranktxt.printf("順位\t選手名\t最近出場日\t勝率\t持ち点\t%s順位",date)

wkdir = RatingFiles.new
meibo1_file = wkdir.fullpath_rankfile(meibo1)
date0 = date

filenum = 0
fname = []
i = 1

# 「month/day順位」の繰り返し出力
while i <= filemax
	if meibo1 = rankfile.gets
		meibo1.chomp!
		date_m = meibo1.slice(4,2).to_i
		date_d = meibo1.slice(6,2).to_i
		date = sprintf("%d/%d",date_m, date_d)
		if date != date0
			ranktxt.printf("\t%s順位",date)
			filenum += 1
			meibo1_path = wkdir.fullpath_rankfile(meibo1)
			fname.push meibo1_path
			date0 = date
		end
	else
		break
	end
	i += 1
end
ranktxt.printf("\n")
rankfile.close

#---------------------------------------------
# 最新ランクの選手順で順位変動を出力する。
#---------------------------------------------
rankd1 = File.open(meibo1_file, "r")
while s = rankd1.gets
	s.chomp!
	a = []
	a = s.split(/\t/)
	p1 = a[RK_RANK].to_i
	p2 = a[RK_NAME]
	p3 = a[RK_DAY]
	p4 = a[RK_WIN].to_f / a[RK_GAME].to_f
	p5 = a[RK_PT].to_i
	p6 = a[RK_RANK].to_i

	# 各選手のデータを出力をする
	ranktxt.printf("%d\t%s\t%s\t%\.3f\t%d\t%d",p1,p2,p3,p4,p5,p6)
	STDERR.printf("%d\t%s\n",p1,p2)

	# 最新から遡ってランキングを参照する
	i = 1
	while i <= filenum
		m1 = fname[i - 1]
		f = File.open(m1, "r")
		juni = 0

		# 該当選手を検索して順位を得る
		while s2 = f.gets
			s2.chomp!
			b = []
			b = s2.split(/\t/)
			if a[RK_CODE] == b[RK_CODE]
				juni = b[RK_RANK]
				break
			end
		end
		f.close

		# 該当選手の順位の出力
		if juni == 0
			ranktxt.printf("\t\-")
		else
			ranktxt.printf("\t%d",juni)
		end

		i += 1
	end
	ranktxt.printf("\n")

end
ranktxt.close
rankd1.close

