#!ruby
#**********************************************************************
# ruby p7_rankhtml.rb
#----------------------------------------------------------------------
# 公開用ランキングを作成する（ランキング対象：対象選手の上位200名/最大5日分）
# 入力
#   FILE_RANKFILE   逆順の.d1ランクファイル一覧
# 出力
#   FILE_RANKHTML   公開用ランキングHTMLファイル
#----------------------------------------------------------------------

require 'fileutils'
require './def_rating_files'
require './def_rating_meibo'


# 推移を表示する最大日数
filemax = 5

# 表示する上位の対象選手数
rankout = 200

#######################################################################
# メインプログラム

#---------------------------------------------
# 項目名の行を出力する。
#---------------------------------------------
rankfile = File.open(FILE_RANKFILE, "r")
rankhtml = File.open(FILE_RANKHTML, "w")

meibo1 = rankfile.gets
meibo1.chomp!
date_m = meibo1.slice(4,2)
date_d = meibo1.slice(6,2)
date = sprintf("%d/%d",date_m.to_i, date_d.to_i)

rankhtml.printf("<HTML>\n<HEAD>\n")
rankhtml.printf("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n")
rankhtml.printf("<TITLE>Karuta Ranking</TITLE></HEAD>\n")
rankhtml.printf("<BODY bgcolor=\"aaffff\" text=\"#000088\">\n")
rankhtml.printf("<A HREF=\"../../index.htm\">トップ</A>　　<A HREF=\"../rating.htm\">レーティング</A><BR>\n<HR>\n")
rankhtml.printf("<H3>競技かるたＡ級選手レーティングランキング <I><FONT COLOR=\"#ff00aa\">Top</FONT> ２００</I></H3>\n")

tm = Time.now
rankhtml.printf("集計日：%d年%d月%d日<BR>\n", tm.year, tm.month, tm.day)

rankhtml.printf("<TABLE border=1 bgcolor=\"#eeeeee\">\n")
rankhtml.printf("<TR bgcolor=\"#00cc00\"><TH>順位</TH><TH>選手名</TH><TH>所属会</TH><TH>最近出場日</TH><TH>勝率</TH><TH>持ち点</TH><TH>%s順位</TH>",date)

wkdir = RatingFiles.new
meibo1_file = wkdir.fullpath_rankfile(meibo1)
date0 = date

filenum = 0
fname = []
i = 1

# 「month/day順位」の繰り返し出力
while i < filemax
	if meibo1 = rankfile.gets
		meibo1.chomp!
		date_m = meibo1.slice(4,2).to_i
		date_d = meibo1.slice(6,2).to_i
		date = sprintf("%d/%d",date_m, date_d)
		if date != date0
			rankhtml.printf("<TH>%s順位</TH>",date)
			filenum += 1
			meibo1_path = wkdir.fullpath_rankfile(meibo1)
			fname.push meibo1_path
			date0 = date
			i += 1
		end
	else
		break
	end
end
rankhtml.printf("</TR>\n")
rankfile.close

#---------------------------------------------
# 最新ランクの選手順で順位変動を出力する。
#---------------------------------------------
rankd1 = File.open(meibo1_file, "r")
while s = rankd1.gets
	s.chomp!
	a = []
	a = s.split(/\t/)

	if a[RK_RANK].to_i > rankout
		break
	end

	p1 = a[RK_RANK].to_i
	p2 = a[RK_NAME]
	p3 = a[RK_KAI]
	p4 = a[RK_DAY]
	p5 = a[RK_WIN].to_f / a[RK_GAME].to_f
	p6 = a[RK_PT].to_i
	p7 = a[RK_RANK].to_i

	# 各選手のデータを出力をする
	rankhtml.printf("<TR><TD>%d</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD><TD>%.3f</TD><TD align=\"center\">%d</TD><TD align=\"center\">%d</TD>",p1,p2,p3,p4,p5,p6,p7)

	# 最新から遡ってランキングを参照する
	i = 1
	while i <= filenum
		m1 = fname[i - 1]
		f = File.open(m1, "r")
		juni = 0

		# 該当選手を検索して順位を得る
		while s2 = f.gets
			s2.chomp!
			b = []
			b = s2.split(/\t/)
			if a[RK_CODE] == b[RK_CODE]
				juni = b[RK_RANK]
				break
			end
		end
		f.close

		# 該当選手の順位の出力
		if juni == 0
			rankhtml.printf("<TD align=\"center\">\-</TD>")
		else
			rankhtml.printf("<TD align=\"center\">%d</TD>",juni)
		end

		i += 1
	end
	rankhtml.printf("</TR>\n")

end
rankhtml.printf("</TABLE>\n</BODY></HTML>\n")
rankhtml.close
rankd1.close

